module Ubc.Parse.Types
( checkTypeValidity
, getTypeNames
)
where

import Text.Parsec

import qualified Data.Set as Set

import Ubc.Parse.ParserState (ParserState)

checkTypeValidity :: Monad m => String -> ParsecT String ParserState m Bool
checkTypeValidity typeName = do
        typeNames <- getTypeNames >>= return . Set.union (Set.fromList ["i32", "u32", "f32"]) . Set.fromList
        return $ typeName `Set.member` typeNames

getTypeNames :: Monad m => ParsecT String ParserState m [String]
getTypeNames = do
        return []
